from __future__ import with_statement
print "b41"
os.chdir("/home/was/sd5/sato-tate/sage_notebook/worksheets/admin/2/cells/2")
#auto
from math import asin, log, sqrt

def line1(xmin,xmax):
    return line([(xmin,Integer(1)),(xmax,Integer(1))], rgbcolor=(Integer(1),Integer(0),Integer(0)))

def Xab(a,b):
    bb = (asin(b)/2 + b*sqrt(1-b**2)/2)
    aa = (asin(a)/2 + a*sqrt(1-a**2)/2)
    def X(T):
        return (asin(T)/2 + T*sqrt(1-T**2)/2 - aa)/(bb - aa)
    return X

import bisect

class SatoTate:
    def __init__(self, E):
        self._E = E

    def __repr__(self):
        return "Sato-Tate data for %s"%self._E

    def anlist(self, n):
        return self._E.anlist(n)

    def normalized_aplist(self, n):
        t = cputime()
        anlist = self.anlist(n)
        print cputime(t)
        two = float(Integer(2))
        v = [float(anlist[p])/(two*sqrt(p)) for p in prime_range(n)]
        return v

    def sorted_aplist(self, n):
        v = self.normalized_aplist(n)
        v.sort()
        return v

    def YCab(self, Cmax, a=-Integer(1), b=Integer(1)):
        v = self.sorted_aplist(Cmax)
        return lambda T: float(Integer(1))

        denom = bisect.bisect_right(v, float(b)) - bisect.bisect_left(v, float(a))
        try:
           normalize = float(Integer(1))/denom
        except:
           def Y(T):
               return 1.0
           return Y
        start_pos = bisect.bisect_left(v, float(a))

        def Y(T):
            # find position that T would go in if it were inserted
            # in the sorted list v.
            n = bisect.bisect_right(v, float(T)) - start_pos
            return n * normalize
        return Y


    def xyplot(self, C, a=-Integer(1), b=Integer(1)):
        """
        Return the quantile-quantile plot for given a,b, up to C.
        """
        Y = self.YCab(C,a=a,b=b)
        X = Xab(a=a,b=b)
        pX = plot(X, a, b, rgbcolor=(Integer(1),Integer(0),Integer(0)))
        pY = plot(Y, a, b, rgbcolor=(Integer(0),Integer(0),Integer(1)))
        return pX + pY

    def qqplot(self, C, a=-Integer(1), b=Integer(1)):
        """
        Return the quantile-quantile plot for given a,b, up to C.
        """
        Y = self.YCab(C,a=a,b=b)
        X = Xab(a=a,b=b)
        pl = parametric_plot((X, Y), a,b)
        ll = line([(Integer(0),Integer(0)), (RealNumber('1.1'),RealNumber('1.1'))], rgbcolor=(Integer(1),Integer(0),Integer(0)))
        return pl+ll

    def Delta(self, C, a, b, max_points=Integer(300), L_norm=Integer(2)):
        """
        Delta_{a}^{b} function:

        INPUT: C - cutoff
             a,b - evaluate over the interval (a,b)
             max_points - number of points used in numerical integral
             L_norm --the integer n=2 or n=oo.
                      Compute the L_n norm.   For n finite this
                      is the integral of the difference to the power n.
                      For n = +oo, this is the L_oo norm, which is the max
                      of the absolute value of the difference (where the max
                      is evaluated at max_points equidistributed points).
        """
        key = (C,a,b,max_points, L_norm)
        try:
           return self._delta[key]
        except AttributeError:
           self._delta = {}
        except KeyError:
           pass
        X = Xab(a,b)
        Y = self.YCab(C,a,b)     # This takes all the time.

        if L_norm == oo:
            val = max([abs(X(T)-Y(T)) for T in srange(a,b,float(b-a)/max_points)])
            err = Integer(0)
        else:
            n = int(L_norm)   # usually n = 2.
            def h(T):
                return (X(T) - Y(T))**n
            val, err = integral_numerical(h, a, b, max_points=max_points,
              algorithm='qag', rule=Integer(1),eps_abs=RealNumber('1e-10'), eps_rel=RealNumber('1e-10'))
            val = float(val**(RealNumber('1.0')/n)) # compute L_n norm.
            err = float(err**(RealNumber('1.0')/n))

        self._delta[key] = (val, err)
        return val, err

    def theta(self, C, a=-Integer(1), b=Integer(1), max_points=Integer(300), L_norm=Integer(2)):
        val, err = self.Delta(C, a, b, max_points=max_points, L_norm=L_norm)
        return -log(val)/log(C), val, err

    def theta_interval(self, C, a=-Integer(1), b=Integer(1), max_points=Integer(300), L_norm=Integer(2)):
        val, err = self.Delta(C, a, b, max_points=max_points, L_norm=L_norm)
        return -log(val-abs(err))/log(C), -log(val+abs(err))/log(C)

    def compute_theta(self, Cmax, plot_points=Integer(30), a=-Integer(1), b=Integer(1),
                 max_points=Integer(300), L_norm=Integer(2), verbose=False):
        a,b = (float(a), float(b))
        def f(C):
           z = self.theta(C, a, b, max_points=max_points, L_norm=L_norm)
           if verbose: print C, z
           return z[Integer(0)]
        return [(x,f(x)) for x in range(Integer(100), Cmax, int(Cmax/plot_points))]

    def compute_theta_interval(self, Cmax, plot_points=Integer(30), a=-Integer(1), b=Integer(1),
                max_points=Integer(300), L_norm=Integer(2), verbose=False):
        a,b = (float(a), float(b))
        vmin = []; vmax = []
        for C in range(Integer(100), Cmax, int(Cmax/plot_points)):
            zmin,zmax = self.theta_interval(C, a, b, max_points=max_points, L_norm=L_norm)
            vmin.append((C, zmin))
            vmax.append((C, zmax))
            if verbose: print C, zmin, zmax
        return vmin, vmax

    def plot_theta_interval(self, Cmax, clr=(Integer(0),Integer(0),Integer(0)), *args, **kwds):
        vmin, vmax = self.compute_theta_interval(Cmax, *args, **kwds)
        v = self.compute_theta(Cmax, *args, **kwds)
        grey = (RealNumber('0.7'),RealNumber('0.7'),RealNumber('0.7'))
        return line(vmin,rgbcolor=grey)+line(vmax,rgbcolor=grey) +                 point(v,rgbcolor=clr) + line(v,rgbcolor=clr) + line1(Integer(0), Cmax)

    def histogram(self, Cmax, num_bins):
        v = self.normalized_aplist(Cmax)
        d, total_number_of_points = dist(v, num_bins)
        return frequency_histogram(d, num_bins, total_number_of_points) + semicircle

    def x_times_Delta(self, x):
        return x*self.Delta(x, -Integer(1),Integer(1), max_points=Integer(500))[Integer(0)]

print "e41"
